#! /usr/bin/env python2.5

from merescocore.framework import be
from merescocore.components import readConfig
from merescocore.components.http import ObservableHttpServer
from bzv.oaiserver import main
from weightless import Reactor
from sys import stderr, stdout, argv
from bzv.infra import Infra
import sys
import syslog
import sys, traceback

#if len(args) == 1:
#    configFile = args[0]
#    config = readConfig(configFile)

args = argv[1:]
if len(args) == 1:
    oaiConfigFile = args[0]

print oaiConfigFile

# Infra needs a logfile at startup
infra = Infra('Starting oaiserver', configFile=oaiConfigFile)
configRoot = infra.configRoot
logging = infra.logging
logger = logging.getLogger('meresco.server')
logging.info('Starting oai-server logging')
logger.info('Starting oai-server logger')


config = configRoot.getSectionDict('oai')
logger.info(infra.prpt('config', config))

# Onderschep 'buitenste' exception en toon deze in syslog (zie: http://docs.python.org/library/sys.html)
def hooked(type, value, tb):
    syslog.syslog('oai-server: FATAL')
    dump = traceback.format_exception(type, value, tb)
    for  line in dump:
        syslog.syslog(line)

    # print ook naar stderror:
    traceback.print_exception(type, value, tb)

sys.excepthook = hooked;

reactor = Reactor()
oaiPortNumber=int(config['oaiportnumber'])

observableHttpServer = ObservableHttpServer(reactor, oaiPortNumber)
observableHttpServer.startServer()

processorHelix, serverHelix = main(reactor,
	observableHttpServer, 
	inboxDirectory=config['inboxdirectory'],
	doneDirectory=config['donedirectory'],
	databasePath=config['databasepath'],
	oaiAdminEmail=config['oaiadminemail'],
	oaiRepositoryName=config['oairepositoryname'],
    stdoutStream=stdout,
    stderrStream=stderr)

processor = be(processorHelix)
server = be(serverHelix)
processor.once.observer_init()
server.once.observer_init()

print "Ready to rumble at port %s." % int(config['oaiportnumber'])
stdout.flush()
reactor.loop()
